## Script (Python) "subevent_handler"
##bind container=container
##bind context=context
##bind namespace=
##bind script=script
##bind subpath=traverse_subpath
##parameters=
##title=

req = context.REQUEST
user = context.portal_membership.getAuthenticatedMember()
isReview = user.has_role('Reviewer')
isMan = user.has_role('Manager')
medianet = context.portal_medianet

create_or_save = req.get('create_or_save', None)
manipulate_subevents = req.get('manipulate_subevents', None)

if not req.has_key('return_skin'):
    return req.RESPONSE.redirect(context.absolute_url() + '?portal_status_message=return+skin+missing')


if create_or_save:
    if create_or_save == 'create':
        #print 'creating new subevent\n'
        sub_e_id = medianet.getUniqueID()
        event = medianet.getEventFor(context)
        event.invokeFactory(id=sub_e_id, type_name='Sub Event')
        subevent = getattr(event, sub_e_id)
        start = DateTime(req.get('start_date')).strftime('%Y/%m/%d')
        stop = DateTime(req.get('stop_date')).strftime('%Y/%m/%d')
        subevent.edit(title=req.get('title')
                           , description=req.get('description')
                           , effectiveDate=start
                           , expirationDate=stop
                           , start_time=req.get('start_time')
                           , stop_time=req.get('stop_time'))
        status_msg = 'Created new sub event'
    elif create_or_save == 'create_with_mark':
        event = medianet.getEventFor(context)
        sub_e_id = medianet.getUniqueID()
        event_start = event.start().AMPMMinutes()
        subevents = event.objectValues('Media Manager Sub Event')
        #print "subevents: %s" % str(subevents)
        last = None
        # get the last subevent
        if len(subevents) > 0: # if we can get the last sub event we use its end time as start time
            last = subevents[len(subevents)-1]
        event.invokeFactory(id=sub_e_id, type_name='Sub Event')
        subevent = getattr(event, sub_e_id)
        if 0: #last:
            stop = DateTime(req.get('stop_date')).strftime('%Y/%m/%d')
            subevent.edit(title=req.get('title')
                               , description=req.get('description')
                               , expirationDate=stop
                               , stop_time=req.get('stop_time'))
            subevent.setStartDate(last.end())
        else:
            start = DateTime(req.get('start_date')).strftime('%Y/%m/%d')
            stop = DateTime(req.get('stop_date')).strftime('%Y/%m/%d')
            subevent.edit(title=req.get('title')
                               , description=req.get('description')
                               , effectiveDate=start
                               , expirationDate=stop
                               , start_time=req.get('start_time')
                               , stop_time=req.get('stop_time'))
        status_msg = 'Created new sub event and set time&new_start_time=%s' % req.get('stop_time')
        #return printed
    elif create_or_save == 'save':
        subevent = context
        start = DateTime(req.get('start_date')).strftime('%Y/%m/%d')
        stop = DateTime(req.get('stop_date')).strftime('%Y/%m/%d')
        subevent.edit(title=req.get('title')
                           , description=req.get('description')
                           , effectiveDate=start
                           , expirationDate=stop
                           , start_time=req.get('start_time')
                           , stop_time=req.get('stop_time'))
        status_msg = 'Saved sub event'
elif manipulate_subevents:
    if req.has_key('delete'):
        context.manage_delObjects(manipulate_subevents, req)
        status_msg = 'Deleted sub events'
        return_url = "%s/%s?portal_status_message=%s&refresh_form=true" % \
        (context.absolute_url(), req.get('return_skin'), status_msg.replace(' ', '+'))
        return req.RESPONSE.redirect(return_url)
    elif req.has_key('change_status'):
        if req.has_key('state_change'):
            for id in manipulate_subevents:
                obj = context.restrictedTraverse(id)
                try:
                    context.portal_workflow.doActionFor(obj, req.get('state_change'))
                except:
                    pass
            status_msg = 'Status+changed+to+%s.' % (req.get('state_change'))
        else:
            status_msg = 'No+new+status+selected'
    elif req.has_key('convert'):
        if not req.has_key('mediaevent'):
            req.RESPONSE.redirect(context.absolute_url() + '?portal_status_message=No+event+selected!')
        event = medianet.restrictedTraverse(req.get('mediaevent'))
        event_start = DateTime(context.start().AMPMMinutes()).Time()

        # are we just looking for one master file here?
        for m in context.objectValues('Media Manager Master File'):
            master_url = m.absolute_url(relative = 1)
            master_title = m.title
        trans = {'':'ae','':'oe','':'aa','':'Ae','':'Oe','':'Aa',' ':'_','.':''}
        master_title_trans = master_title
        for l in trans.keys(): # I would love to be better at regular expression (thomas)
            master_title_trans = string.replace(master_title_trans, l, trans[l])
        item_count = 0
        for id in manipulate_subevents:
            item_count = item_count + 1
            obj = context.restrictedTraverse(id)
            clip_id = '%s_%d' % (medianet.getUniqueID(), item_count)
            start_strings = obj.getStartStrings()
            start_date = '%s/%s/%s' % (start_strings['year'], start_strings['month'], start_strings['day'])
            #print 'Calling invokeFactory width id: %s\n' % clip_id
            event.invokeFactory(id=clip_id, type_name='Media Clip')
            cobj = getattr(event, clip_id)
            tcin = "%s.000" % str(context.getOffset(event_start, obj.start().strftime('%H:%M:%S')))
            tcout = "%s.000" % str(context.getOffset(event_start, obj.end().strftime('%H:%M:%S')))
            cobj.setTimeCodes(tcin, tcout, relative=1)
            #print 'Calling editMetadata width title: %s, effective_date: %s\n' % (obj.title, start_date)
            cobj.editMetadata(title=obj.title, description=obj.description, effective_date=start_date, expiration_date='9999/01/01')
            clip_title_trans = obj.title
            for l in trans.keys(): # I would love to be better at regular expression (thomas)
                clip_title_trans = string.replace(clip_title_trans, l, trans[l])
            cobj.setMasterFilePath(master_url)
            event.addClip(cobj.absolute_url(relative=1))
        #return printed
        status_msg = 'Clip(s)+created'
else:
    status_msg = 'Please+select+one+or+more+sub+events+before+trying+to+apply+an+action.'
return req.RESPONSE.redirect("%s/%s?portal_status_message=%s&refresh_marklist=true" % \
(context.absolute_url(), req.get('return_skin'), status_msg.replace(' ', '+')))